config/routes.rb
Rails.application.routes.draw do
  resources :task_lists
  resources :tasks
  # For details on the DSL available within this file, see https://guides.rubyonrails.org/routing.html

  root 'task_lists#index'
end

app/models/application_record.rb
class ApplicationRecord < ActiveRecord::Base
  self.abstract_class = true
end

app/models/task.rb
class Task < ApplicationRecord
  belongs_to :task_list

  validates :name, presence: true,  uniqueness: { scope: :task_list_id }
  scope :completed, -> { where(completed: true) }
end

app/models/task_list.rb
class TaskList < ApplicationRecord
  has_many :tasks, dependent: :destroy

  validates :name, presence: true, uniqueness: true

  def completed_tasks
    tasks.completed.count
  end
end

app/controllers/application_controller.rb
class ApplicationController < ActionController::Base
end

app/controllers/task_lists_controller.rb
class TaskListsController < ApplicationController
  before_action :set_task_list, only: [:edit, :show, :update, :destroy]

  def index
    @task_lists = TaskList.all
    @task = Task.new
  end

  def new
    @task_list = TaskList.new
    render :form
  end

  def create
    @task_list = TaskList.new(task_list_params)
    if @task_list.save
      flash[:notice] =  "Lista de tareas creada exitosamente"
      redirect_to root_path
    else
      flash.now[:notice] = "Hubo algun problema al intentar crear la lista"
      render :form
    end
  end

  def show
    @task = Task.new
  end

  def edit
    render :form
  end

  def update
    if @task_list.update(task_list_params)
      redirect_to @task_list, notice: "La lista ha sido actualizada correctamente"
    else
      redirect_to @task_list, notice: "Hubo algun problema al actualizar la lista"
    end
  end

  def destroy
    @task_list.destroy
    flash[:notice] = "La lista ha sido eliminada correctamente"
    redirect_to root_path
  end

  private

  def task_list_params
    params.require(:task_list).permit(:name, :id)
  end

  def set_task_list
    @task_list = TaskList.find(params[:id])
  end
end

app/controllers/tasks_controller.rb
class TasksController < ApplicationController
  before_action :set_task, only: [:edit, :update, :destroy]

  def new
    @task = Task.new
  end

  def create
    @task = Task.new(task_create_params)
    if @task.save
      flash[:notice] =  "Tarea creada exitosamente"
    else
      flash[:notice] = "Hubo algun problema al intentar crear la tarea"
    end
    redirect_back(fallback_location: root_path)
  end

  def edit
  end

  def update
    if @task.update(task_update_params)
      flash[:notice] = 'La tarea ha sido actualizada correctamente'
      redirect_back(fallback_location: root_path)
    else
      flash[:notice] = 'Hubo algun problema al actualizar la tarea'
      redirect_back(fallback_location: root_path)
    end
  end

  def destroy
    @task.destroy
    flash[:notice] = "La tarea ha sido eliminada correctamente"
    redirect_back(fallback_location: root_path)
  end

  private

  def task_create_params
    params.require(:task).permit(:name, :task_list_id)
  end

  def task_update_params
    params.require(:task).permit(:completed)
  end

  def set_task
    @task = Task.find(params[:id])
  end
end

app/helpers/application_helper.rb
module ApplicationHelper
end

app/helpers/task_lists_helper.rb
module TaskListsHelper
  def linked_name(task_list)
    link_to task_list.name, task_list_path(task_list)
  end
end

app/views/layouts/application.html.erb
<!DOCTYPE html>
<html>
  <head>
    <title>TaskListApp</title>
    <meta name="viewport" content="width=device-width,initial-scale=1">
    <%= csrf_meta_tags %>
    <%= csp_meta_tag %>

    <%= stylesheet_link_tag 'application', media: 'all', 'data-turbolinks-track': 'reload' %>
    <%= javascript_pack_tag 'application', 'data-turbolinks-track': 'reload' %>
    <script src="https://kit.fontawesome.com/3cc9a549c3.js" crossorigin="anonymous"></script>
  </head>

  <body>
    <% flash.each do |type, msg| %>
      <div class="alert alert-info">
        <%= msg %>
      </div>
    <% end %>
    <%= yield %>
  </body>
</html>

app/views/task_lists/_task_list.html.erb
  <div class="row pad-top pad-left">
    <div class="col-md-4 to-left pad-top pad-left">
      <%= linked_name(task_list) %>
      <br>
      <%= render task_list.tasks %>
      <%= form_with model: @task do |form| %>
        <div class="input-group">
          <%= form.hidden_field :task_list_id, value: task_list.id %>
          <%= form.text_field :name, placeholder: "Nueva tarea...", size: "15" %>
          <%= form.submit "Crear", class: 'btn btn-success btn-sm' %>
        </div>
        <br>
      <% end %>
      <p class="italic"><%= pluralize(task_list.completed_tasks, "tarea completada", "tareas completadas") %></p> 
    </div>
  </div>

app/views/task_lists/form.html.erb
<div class="pad-top pad-left">
  <% if @task_list.persisted? %>
    <h4><%= "#{@task_list.name}" %></h4>
  <% else %>
    <h4>Crear Lista</h4>
  <% end %>
  <div class="col-md-3 some-padding">
    <%= form_with model: @task_list do |form| %>
      <%= form.label "Nombre de la lista" %>
      <div class="some-padding">
        <%= form.text_field :name %>
      </div>
      <div>
        <%= form.submit "Guardar lista", class: 'btn btn-success btn-sm' %>
        <%= link_to "Volver", root_path %>
      </div>
    <% end %>
  </div>
</div>

app/views/task_lists/index.html.erb
<div class="container">
  <div class="row pad-top pad-left">
    <div class="col-md-3">
      <h3>Lista de Tareas</h3>
    </div>
    <div class="col-md-3 offset-md-6">
      <%= link_to "Nueva lista de tareas", new_task_list_path, class: "btn btn-primary" %>
    </div>
  </div>
  <%= render @task_lists.sort_by(&:name) %>
</div>

app/views/task_lists/show.html.erb
<div class="container">
  <div class="row pad-top pad-left">
    <div class="col-md-4">
      <h3><%= "#{@task_list.name}" %></h3>
    </div>
    <div class="col-md-1 offset-md-4">
      <%= link_to "Volver", root_path %>
    </div>
    <div class="col-md-1">
      <%= link_to "Editar", edit_task_list_path, class: "btn btn-primary btn-sm" %>
    </div>
    <div class="col-md-1">
      <%= button_to "Eliminar", @task_list, method: :delete, class: "btn btn-danger btn-sm" %>
    </div>
  </div>
  
  <%= render @task_list %>
  <br>
  <h6>Tareas Completadas</h6>
  <% @task_list.tasks.each do |task| %>
    <% if task.completed? %>
      <p class="crossed-italic"><%= task.name %></p>
    <% end %>
  <% end %>
</div>

app/views/tasks/_task.html.erb
<% unless task.completed? %>
  <div class="block some-padding">
    <%= task.name %>
    <div class="marg-left">
      <%= button_to task, params: { task: { completed: true } }, method: :patch, class: "btn btn-info btn-sm", id: "complete-#{task.name}" do %>
      <span class= "far fa-check-square fa-lg"></span>
      <% end %>
    </div> 
    <div class="marg-left">
      <%= button_to task, method: :delete, class: "btn btn-danger btn-sm", id: "delete-#{task.name}" do %>
        <span class= "fas fa-trash"></span>
      <% end %>
    </div> 
  </div> 
<% end %> 